import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigDecimal;
import java.math.BigInteger;

public class Factorial {
    public static BufferedReader br;

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        String line;
        while ((line = br.readLine()) != null) {
            int n = Integer.parseInt(line);
            System.out.println(doubleFact(n));
        }
    }

    public static long doubleFact(int n) {
        long result = 1;
        if (n%2 == 0) {
            for (int k = 1; k <= n/2; k++) {
                result = (result * 2 * k) % 10010101;
            }
        }
        else {
            for (int k = 1; k <= (n+1)/2; k++) {
                result = result * ((2 * k) - 1) % 10010101;
            }
        }
        return result;
    }
}
